﻿
Friend Class ActiveDirectoryHelper

    Public Shared Function GetSingleDomainController(ByVal DomainName As String, ByVal ConnectionUsername As String, ByVal ConnectionPassword As String) As String
        Return DirectoryServices.ActiveDirectory.Domain.GetDomain(GetDomainContext(DomainName, ConnectionUsername, ConnectionPassword)).FindDomainController.Name
    End Function

    Public Shared Function GetDomainContext(ByVal DomainName As String, ByVal ConnectionUsername As String, ByVal ConnectionPassword As String) As DirectoryServices.ActiveDirectory.DirectoryContext
        If String.IsNullOrEmpty(ConnectionUsername) Then
            Return New DirectoryServices.ActiveDirectory.DirectoryContext(DirectoryServices.ActiveDirectory.DirectoryContextType.Domain, DomainName)
        Else
            Return (New DirectoryServices.ActiveDirectory.DirectoryContext(DirectoryServices.ActiveDirectory.DirectoryContextType.Domain, DomainName, ConnectionUsername, ConnectionPassword))
        End If
    End Function

    Public Shared Function GetLocalDomainName() As String
        Return DirectoryServices.ActiveDirectory.Domain.GetCurrentDomain.Name
    End Function

End Class
